Path: dp-news.maxwell.syr.edu!spool.maxwell.syr.edu!news-spur1.maxwell.syr.edu!news.maxwell.syr.edu!news-out.readnews.com!news-xxxfer.readnews.com!postnews.google.com!news4.google.com!border1.nntp.dca.giganews.com!nntp.giganews.com!nf3.bellglobal.com!ursa-nb00s0.nbnet.nb.ca!53ab2750!not-for-mail
From: Bob Badour <bbadour@pei.sympatico.ca>
User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.2) Gecko/20040804 Netscape/7.2 (ax)
X-Accept-Language: en-us, en
MIME-Version: 1.0
Newsgroups: comp.databases.theory
Subject: Re: 3 value logic. Why is SQL so special?
References: <EJpMg.15039$9u.165112@ursa-nb00s0.nbnet.nb.ca>   <1157999788.299752.224050@b28g2000cwb.googlegroups.com>   <arudg216mnqquils6h64aulvirr8j02hk8@4ax.com>   <1158105934.549881.4140@p79g2000cwp.googlegroups.com>   <x_INg.532276$Mn5.145502@pd7tw3no>   <1158181597.064456.70460@i42g2000cwa.googlegroups.com>   <1158408483.858693.203290@b28g2000cwb.googlegroups.com>   <eemdi3$1t3$1@nntp.fujitsu-siemens.com>   <h3htg2hlprsaaefku7gpfakp6cgtqlp13n@4ax.com>   <HaudnZ5V94X7aZPYRVnygg@pipex.net>   <1158613110.059626.258460@d34g2000cwd.googlegroups.com>   <phKPg.22749$9u.270787@ursa-nb00s0.nbnet.nb.ca>   <1158641743.782237.256850@i3g2000cwc.googlegroups.com>   <1158642255.069101.30980@h48g2000cwc.googlegroups.com>   <opidnVD6manyCJLYRVnyrQ@pipex.net>   <1158651482.204488.296170@i42g2000cwa.googlegroups.com>   <or6dne8UYrTTNpLYnZ2dnUVZ8qCdnZ2d@pipex.net> <1158656458.843298.310190@m73g2000cwd.googlegroups.com> <-tKdnY_1dP9yXZLYRVnyrA@pipex.net>
In-Reply-To: <-tKdnY_1dP9yXZLYRVnyrA@pipex.net>
Content-Type: text/plain; charset=us-ascii; format=flowed
Content-Transfer-Encoding: 7bit
Lines: 60
Message-ID: <piTPg.22879$9u.274316@ursa-nb00s0.nbnet.nb.ca>
Date: Tue, 19 Sep 2006 14:39:17 GMT
NNTP-Posting-Host: 142.176.114.83
X-Complaints-To: abuse@aliant.net
X-Trace: ursa-nb00s0.nbnet.nb.ca 1158676757 142.176.114.83 (Tue, 19 Sep 2006 11:39:17 ADT)
NNTP-Posting-Date: Tue, 19 Sep 2006 11:39:17 ADT
Organization: Sympatico-Subscriber
Xref: dp-news.maxwell.syr.edu comp.databases.theory:45079

Roy Hann wrote:

> "Chris Lim" <blackcap80@hotmail.com> wrote in message 
> news:1158656458.843298.310190@m73g2000cwd.googlegroups.com...
> 
>>>The compexity doesn't go away.  Any additional tables merely reveal the
>>>complexity that is otherwise hidden, lying in wait but still very much
>>>there.  If you don't resolve it with a complex query you have to resolve 
>>>it
>>>with complex code somewhere else.  As horrid as it is, SQL is still 
>>>almost
>>
>>Isn't it better to hide complexity then, assuming that you end up with
>>the correct result?
> 
> 
> I have no problem hiding irrelevant complexity.  But it has to be 
> understood, and hidden in an appropriate way so that your assumption that 
> the result is correct will always be safe.
> 
> In an ideal DBMS much complexity could be safely hidden inside suitable 
> datatypes.  Of course many/most SQL implementations have very limited 
> support for complex types.  But even so, we do seem to have an urge to 
> introduce spurious complexity even when SQL doesn't impose it on use.  For 
> example, I don't think I've ever seen a database where the internal fine 
> structure of a postal address wasn't layed out in all it's irrelevant glory. 
> I can see why in many businesses you'd want to know the postal code, but the 
> rest of it is usually irrelevant to anyone but the posty walking the route. 
> (And just to be clear, I am sure that there are obscure applications for 
> which one does need to model the fine structure of the postal address, 
> perhaps down to the level of the forward sortation area and local delivery 
> unit.  My point is that much complexity I see is not really dictated by the 
> enterprise of interest at all but is either thoughtlessly introduced, or 
> introduced "just in case" by rogue designers.  Which is ironic since so many 
> would probably then also claim to want to minimize the number of tables "to 
> reduce complexity".)
> 
> Roy
> 
> PS: This is a particularly sore point with me because my address is strange. 
> As a result I regularly have trouble using Internet shopping sites, the GPS 
> in my car can't be told where I live, and I recently had a credit card 
> application declined because they couldn't match my address to some register 
> or other.  In all cases it was because a bunch of database designers got 
> right up themselves modelling irrelevant complexities thus making everyone's 
> life much harder.
> 
> I'm over it now.
> 
> Really. 

I had a similar problem recently. After I filed my correct address with 
the IRS, they discarded half of it because it didn't fit their idea of 
what an address should look like. As a result, I received some very 
important correspondence from them about nine months after the fact. (I 
am dumbfounded I ever received it at all.)

They didn't seem to get the fact that from my perspective the address 
they have on file for me is the address I filed with them on physical 
documents and not the partial address they recorded in their database.
